--- old/usr/src/cmd/sgs/libld/common/place.c	2016-08-25 11:51:57.858127150 -0400
+++ new/usr/src/cmd/sgs/libld/common/place.c	2016-08-25 11:51:57.894978073 -0400
@@ -759,6 +759,9 @@
 		MSG_SCN_EHFRAME,	/* MSG_ORIG(MSG_SCN_EHFRAME) */
 		MSG_SCN_EHFRAME_HDR,	/* MSG_ORIG(MSG_SCN_EHFRAME_HDR) */
 		MSG_SCN_JCR,		/* MSG_ORIG(MSG_SCN_JCR) */
+		MSG_SCN_INITARRAY,	/* MSG_ORIG(MSG_SCN_INITARRAY) */
+		MSG_SCN_FINIARRAY,	/* MSG_ORIG(MSG_SCN_FINIARRAY) */
+		MSG_SCN_PREINITARRAY,	/* MSG_ORIG(MSG_SCN_PREINITARRAY) */
 		0
 	};
 
--- old/usr/src/cmd/sgs/packages/common/SUNWonld-README	2016-08-25 11:51:59.030941149 -0400
+++ new/usr/src/cmd/sgs/packages/common/SUNWonld-README	2016-08-25 11:51:59.067979888 -0400
@@ -1658,3 +1658,4 @@
 5688	ELF tools need to be more careful with dwarf data
 6098	ld(1) should not require symbols which identify group sections be global
 6252	ld should merge function/data-sections in the same manner as GNU ld
+7323	ld(1) -zignore can erroneously discard init and fini arrays as unreferenced
--- old/usr/src/cmd/sgs/rtld/i386/boot.s	2016-08-25 11:52:00.308741747 -0400
+++ new/usr/src/cmd/sgs/rtld/i386/boot.s	2016-08-25 11:52:00.345160058 -0400
@@ -27,7 +27,6 @@
  * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
 
 /*
  * Bootstrap routine for run-time linker.
@@ -95,11 +94,17 @@
 	.type	_rt_boot,@function
 	.align	4
 
+	/ init is called from the _init symbol in the CRT, however .init_array
+	/ are called "naturally" from call_init.  Because of that, we need the
+	/ stack aligned here so that initializers called via _array sections may
+	/ safely use SIMD instructions.
 _rt_alias:
 	jmp	.get_ip			/ in case we were invoked from libc.so
 _rt_boot:
 	movl	%esp,%ebp		/ save for referencing args
 	subl	$EB_MAX_SIZE32,%esp	/ make room for a max sized boot vector
+	andl	$-16,%esp
+	subl	$8,%esp
 	movl	%esp,%esi		/ use esi as a pointer to &eb[0]
 	movl	$EB_ARGV,0(%esi)	/ set up tag for argv
 	leal	4(%ebp),%eax		/ get address of argv
--- old/usr/src/man/man1/ld.1	2016-08-25 11:52:01.324561976 -0400
+++ new/usr/src/man/man1/ld.1	2016-08-25 11:52:01.363771062 -0400
@@ -973,8 +973,8 @@
 .ad
 .sp .6
 .RS 4n
-Appends an entry to the \fB\&.finiarray\fR section of the object being built.
-If no \fB\&.finiarray\fR section is present, a section is created. The new
+Appends an entry to the \fB\&.fini_array\fR section of the object being built.
+If no \fB\&.fini_array\fR section is present, a section is created. The new
 entry is initialized to point to \fIfunction\fR. See \fIInitialization and
 Termination Sections\fR in \fILinker and Libraries Guide\fR.
 .RE
@@ -1147,8 +1147,8 @@
 .ad
 .sp .6
 .RS 4n
-Appends an entry to the \fB\&.initarray\fR section of the object being built.
-If no \fB\&.initarray\fR section is present, a section is created. The new
+Appends an entry to the \fB\&.init_array\fR section of the object being built.
+If no \fB\&.init_array\fR section is present, a section is created. The new
 entry is initialized to point to \fIfunction\fR. See \fIInitialization and
 Termination Sections\fR in \fILinker and Libraries Guide\fR.
 .RE
